package io.core.agents;

import salsa.language.Message;

public interface ProfilingAgent {
	//The following methods notifiy the profiling agent of
	//actors entering and exiting the theater due to 
	//migration and binding
	public void actorEnter(String identifier);
	public void actorExit(String identifier);

	//When an actor is bound to the local theater, its identifier
	//is updated to its new UAN with this method
	public void updateIdentifier(String uanIdentifier, String ualIdentifier);

	//The profiling agent updates its actor profiles based on
	//message sending with these methods
	public void beginSend(String identifier, Message message);
	public void endSend(String identifier, Message message);

	//The profiling agent updates its actor profiles based on
	//message reception with this method
	public void received(String identifier, Message message);

	//The following methods notify the profiling agent of
	//the start of a message being processed and the end
	//of a message being processed, with a UAN or UAL to
	//identify the sending actor
	public void beginProcessed(String identifier);
	public void endProcessed(String identifier);
}
