/*
	Code generation for the following grammar segment:

	CompilationUnit := 
		[ModuleDeclaration()] 
		(ImportDeclaration())* 
		[BehaviorDeclarationAttributes()]
		( BehaviorDeclaration() | InterfaceDeclaration() )
 */

package salsac.definitions;

import salsac.*;

public class CompilationUnit extends SimpleNode {
	public CompilationUnit(int id) 			{ super(id); }
	public CompilationUnit(SalsaParser p, int id)	{ super(p, id); }

	public String getChildCode() {
		int place = 0;

		String code = "";
		if (getChild(0) instanceof ModuleDeclaration) {
			code += getChild(0).getJavaCode();
			place++;
		}

		code += "// Import declarations generated by the SALSA compiler, do not modify.";
		code += "import java.io.IOException;\n";
		code += "import java.util.Vector;\n";
		code += "import salsa.language.Actor;\n";
		code += "import salsa.language.ActorReference;\n";
		code += "import salsa.language.Message;\n";
		code += "import salsa.language.ServiceFactory;\n";
		code += "import salsa.language.Token;\n";
		code += "import salsa.language.exceptions.*;\n";
		code += "import salsa.naming.UAN;\n";
		code += "import salsa.naming.UAL;\n";
		code += "import salsa.naming.exceptions.*;\n\n";

		for (int i = place; i < children.length; i++) {
			code += getChild(i).getJavaCode();
		}

		SalsaCompiler.indent = 0;
		return code;
	}
}
