/*
	Code generation for the following grammar segment:
	
	ForStatement:=
		"for" "(" [LocalVariableDeclaration() | (StatementExpression() ("," StatementExpression())*)]
			  [Expression()] ";"
			  [StatementExpression() ("," StatementExpression())*] ")" Statement()
*/

package salsac.definitions;

import salsac.*;

public class ForStatement extends SimpleNode {

	public ForStatement(int id) 					{ super(id); }
	public ForStatement(SalsaParser p, int id)	{ super(p, id); }

	public String getJavaCode() {
		String code = "for (";
		
		for (int i = 2; i < tokens.length; i++) {
			code += getChild(i-2).getJavaCode() + getToken(i).image + " ";
		}
		
		code += getChild(children.length-1).getJavaCode();
		
		if (((SimpleNode)parent).parent instanceof Block) {
			return SalsaCompiler.getIndent() + code;
		} else {
			return code;
		}
	}
}
