/*
	Code generation for the following grammar segment:

	FormalParameters :=
		"(" ["final" Type <IDENTIFIER> ( "[" "]" )* ("," ["final"] Type <IDENTIFIER> ("[" "]")* )*] ")"	
*/

package salsac.definitions;

import salsac.*;

public class FormalParameters extends SimpleNode {
	public FormalParameters(int id) 		{ super(id); }
	public FormalParameters(SalsaParser p, int id)	{ super(p, id); }

	public String getParameterNames() {
		String code = "";

		int childPlace = 0;

		if (children != null) {
			for (int i = 0; i < tokens.length; i++) {
				if ( getToken(i).image.equals("(") || getToken(i).image.equals(",") ) {
					if (getToken(i+1).image.equals("final")) i++;

					childPlace++;
					code += getToken(i+1);

					if (childPlace != children.length) code += ", ";
				}
			}
		}

		return code;
	}

	public String getChildCode() {
		String code = "";

		int i = 0;
		int j = 0;
		while (i < tokens.length) {
			if (getToken(i).image.equals(",") || getToken(i).image.equals("(")) {
				code += getToken(i).image;

				if (getToken(i).image.equals(",")) code += " ";

				if (!getToken(i+1).image.equals("final")) {
					if (children != null) code += getChild(j).getJavaCode() + " ";
					j++;
				}
			} else {
				code += getToken(i).image;
			}

			i++;
		}

		return code;
	}
}
