/*
	Code generation for the following grammar segments:
	
	PrimaryPrefix :=
		  Literal()
		| "self"
		| "parent" "." <IDENTIFIER>
		| "(" Expression() ")"
		| AllocationExpression()
		| ResultType() "." "behavior"
		| Name()
*/

package salsac.definitions;

import salsac.*;

public class PrimaryPrefix extends SimpleNode {

	public PrimaryPrefix(int id) 			{ super(id); }
	public PrimaryPrefix(SalsaParser p, int id)	{ super(p, id); }

	public String getJavaCode() {
		if (children == null) {

			if ( getToken(0).image.equals("parent") ) return "super." + getToken(2).image;
			if ( getToken(0).image.equals("self") && !(parent.jjtGetParent() instanceof MessageSend) ) return "this";
			else return "self";
		}
		
		switch (getChild(0).id) {
			case SalsaParserTreeConstants.JJTLITERAL:
			case SalsaParserTreeConstants.JJTALLOCATIONEXPRESSION:
			case SalsaParserTreeConstants.JJTNAME:
				return getChild(0).getJavaCode();
			
			case SalsaParserTreeConstants.JJTEXPRESSION:
				return "(" + getChild(0).getJavaCode() + ")";
				
			case SalsaParserTreeConstants.JJTRESULTTYPE:
				return getChild(0) + getTokenCode();
		}
		
		return "";
	}
}
